/////////////////////////////////////////////////////////////////////////////
// GliD3D_texture.cpp : No comment
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Directive

#include "GliD3D.h"
#include "gl2ideal.h"
//#include <GL/glu.h>
#include <stdlib.h>
/////////////////////////////////////////////////////////////////////////////
// Defines / Variables

/////////////////////////////////////////////////////////////////////////////
// Prototypes

/////////////////////////////////////////////////////////////////////////////
// Implements

#define nTmu 0

static GL2IDE_TEXTURE tlookup[GLID3D_TEXMAXADDRESS + 256];
static GL2IDE_TEXTURE *current_texture = &tlookup[0];

inline void SetCurrentTexture(FxU32 StartAddress)
{
	current_texture=&tlookup[StartAddress];
}

FX_ENTRY FxU32 FX_CALL
  grTexCalcMemRequired (
    GrLOD_t lodmin, GrLOD_t lodmax,
    GrAspectRatio_t aspect, GrTextureFormat_t fmt)
{
    TRACEFUNCTION ("grTexCalcMemRequired");

    return GLID3D_TEXCALCMEMREQUIRED;
}

FX_ENTRY FxU32 FX_CALL
  grTexTextureMemRequired (FxU32 evenOdd,
    GrTexInfo * info)
{
    TRACEFUNCTION ("grTexTextureMemRequired");

    return GLID3D_TEXTEXTUREMEMREQUIRED;
}

FX_ENTRY FxU32 FX_CALL
  grTexMinAddress (GrChipID_t tmu)
{
    TRACEFUNCTION ("grTexMinAddress");

    return GLID3D_TEXMINADDRESS;
}

FX_ENTRY FxU32 FX_CALL
  grTexMaxAddress (GrChipID_t tmu)
{
    TRACEFUNCTION ("grTexMaxAddress");

    return GLID3D_TEXMAXADDRESS;
}

FX_ENTRY void FX_CALL grTexNCCTable (GrChipID_t tmu, GrNCCTable_t table)
{
    TRACEFUNCTION ("grTexNCCTable");

//      WARNING("Not supported yet");
}

FX_ENTRY void FX_CALL grTexSource (GrChipID_t tmu, FxU32 startAddress, FxU32 evenOdd,
    GrTexInfo * info)
{
    TRACEFUNCTION ("grTexSource");

    FlushTriangleVertex();

    if (startAddress < 0 || startAddress >= GLID3D_TEXMAXADDRESS || 
    	g_gr_tmu[nTmu].texture[startAddress].texId == TEXID_INVALID)
    {
		ERROROUT ("Wrong source");
		DisableTexture2D();
		return;
    }

    //INT nTmu = grsubGetTmuIndex(tmu);
    // semantically incorrect and/or buggy: only optimized for UltraHLE

    glBindTexture (GL_TEXTURE_2D, g_gr_tmu[nTmu].texture[startAddress].texId);
    SetCurrentTexture(startAddress);

    //g_gr_tmu[nTmu].texture_source_even_odd = evenOdd;
    //g_gr_tmu[nTmu].texture_source_info = *info;
/*    int aw, ah;
    grsubAspectToInt (aw, ah, info->aspectRatio);
    g_gr_tmu[nTmu].aw=aw / 256.0;
    g_gr_tmu[nTmu].ah=ah / 256.0;
*/
    g_gr_tmu[nTmu].aw = current_texture->aw;
    g_gr_tmu[nTmu].ah = current_texture->ah;
}

FX_ENTRY void FX_CALL grTexClampMode (GrChipID_t tmu, GrTextureClampMode_t s_clampmode,
    GrTextureClampMode_t t_clampmode)
{
    TRACEFUNCTION ("grTexClampMode");

//	if (current_texture->s_clampmode==s_clampmode && current_texture->t_clampmode==t_clampmode)
//		return;

	FlushTriangleVertex();

	if(current_texture->s_clampmode != s_clampmode){
		current_texture->s_clampmode = s_clampmode;
	    if (s_clampmode == GR_TEXTURECLAMP_WRAP)
			glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	    else
			glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	}
	if(current_texture->t_clampmode != t_clampmode){
		current_texture->t_clampmode = t_clampmode;
	    if (t_clampmode == GR_TEXTURECLAMP_WRAP)
			glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	    else
			glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	}
}

FX_ENTRY void FX_CALL grTexCombine (GrChipID_t tmu, GrCombineFunction_t rgb_function,
    GrCombineFactor_t rgb_factor, GrCombineFunction_t alpha_function,
    GrCombineFactor_t alpha_factor, FxBool rgb_invert, FxBool alpha_invert)
{
    TRACEFUNCTION ("grTexCombine");
    //INT nTmu = grsubGetTmuIndex(tmu);

    /*g_gr_tmu[nTmu].texture_combine_rgb_function = rgb_function;
    g_gr_tmu[nTmu].texture_combine_rgb_factor = rgb_factor;
    g_gr_tmu[nTmu].texture_combine_alpha_function = alpha_function;
    g_gr_tmu[nTmu].texture_combine_alpha_factor = alpha_factor;*/
}

FX_ENTRY void FX_CALL grTexCombineFunction (GrChipID_t tmu,
    GrTextureCombineFnc_t fnc)
{
    TRACEFUNCTION ("grTexCombineFunction");
/*
    switch (fnc)
    {
    case GR_TEXTURECOMBINE_ZERO:
    case GR_TEXTURECOMBINE_DECAL:
    case GR_TEXTURECOMBINE_OTHER:
    case GR_TEXTURECOMBINE_ADD:
    case GR_TEXTURECOMBINE_MULTIPLY:
    case GR_TEXTURECOMBINE_SUBTRACT:
    case GR_TEXTURECOMBINE_DETAIL:
    case GR_TEXTURECOMBINE_DETAIL_OTHER:
    case GR_TEXTURECOMBINE_TRILINEAR_ODD:
    case GR_TEXTURECOMBINE_TRILINEAR_EVEN:
    case GR_TEXTURECOMBINE_ONE:
		break;
    }
*/
}

FX_ENTRY void FX_CALL grTexDetailControl (GrChipID_t tmu, int lod_bias,
    FxU8 detail_scale,
    float detail_max
)
{
    TRACEFUNCTION ("grTexDetailControl");

//      WARNING("Not supported yet");
}

FX_ENTRY void FX_CALL grTexFilterMode (GrChipID_t tmu, GrTextureFilterMode_t
    minfilter_mode, GrTextureFilterMode_t magfilter_mode)
{
    TRACEFUNCTION ("grTexFilterMode");
    //INT nTmu = grsubGetTmuIndex(tmu);

    FlushTriangleVertex();

	if (current_texture->texture_magfilter_mode != magfilter_mode)
		if (current_texture->texture_magfilter_mode == GR_TEXTUREFILTER_POINT_SAMPLED)
			glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		else
			glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

	if (current_texture->texture_minfilter_mode != minfilter_mode)
		if (current_texture->texture_minfilter_mode == GR_TEXTUREFILTER_POINT_SAMPLED)
			glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		else
			glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
}


FX_ENTRY void FX_CALL grTexLodBiasValue (GrChipID_t tmu, float bias)
{
    TRACEFUNCTION ("grTexLodBiasValue");

//      WARNING("Not supported yet");
}

FX_ENTRY void FX_CALL grTexDownloadMipMap (GrChipID_t tmu, FxU32 startAddress,
    FxU32 evenOdd, GrTexInfo * info)
{
	TRACEFUNCTION ("grTexDownloadMipMap");

	 grTexDownloadMipMapLevel (tmu, startAddress, info->smallLod, info->smallLod,
	    info->aspectRatio, info->format, evenOdd, info->data);
}

FX_ENTRY void FX_CALL grTexDownloadMipMapLevel (GrChipID_t tmu, FxU32 startAddress,
    GrLOD_t thisLod, GrLOD_t largeLod, GrAspectRatio_t aspectRatio,
    GrTextureFormat_t format, FxU32 evenOdd, void *data)
{
    TRACEFUNCTION ("grTexDownloadMipMapLevel");

    FlushTriangleVertex();
    //int nTmu = grsubGetTmuIndex(tmu);

    LPGLID3D_TEXTURE ptex = &g_gr_tmu[nTmu].texture[startAddress];
//    static unsigned char *tbuffer;
    static unsigned char tbuffer[256 * 256 * 4];

    SetCurrentTexture(startAddress);
    if (ptex->texId == TEXID_INVALID)
    {
	    //genereate a new texname
		glGenTextures (1, &ptex->texId);
	    glBindTexture (GL_TEXTURE_2D, ptex->texId);
		glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    	current_texture->texture_minfilter_mode = GR_TEXTUREFILTER_BILINEAR;
    	current_texture->texture_magfilter_mode = GR_TEXTUREFILTER_BILINEAR;
	 	current_texture->s_clampmode = GR_TEXTURECLAMP_WRAP;
    	current_texture->t_clampmode = GR_TEXTURECLAMP_WRAP;
    }else{
	    //create new texture object
	    glBindTexture (GL_TEXTURE_2D, ptex->texId);
	}


    int	aw, ah;
    grsubAspectToInt (aw, ah, aspectRatio);

    current_texture->aw = aw / 256.0;
    current_texture->ah = ah / 256.0;

    //Get size of lod
    const int	w = grsubLodToInt(thisLod) / ah;
    const int	h = grsubLodToInt(thisLod) / aw;
    const int	size = w*h;

    register unsigned char *dest;
    register const unsigned short *src;
//    register int x;
    int		y, i, q;
    GLenum texture_iformat = GL_RGBA4;
    GLenum texture_format = GL_RGBA;
	GLenum texture_type = GL_UNSIGNED_BYTE;
    
    switch (format)
    {
        case GR_TEXFMT_INTENSITY_8:
        case GR_TEXFMT_ALPHA_INTENSITY_88:
        case GR_TEXFMT_AP_88:       // not implemented/
        case GR_TEXFMT_ALPHA_INTENSITY_44:
        case GR_TEXFMT_P_8:
        break;
      case GR_TEXFMT_ALPHA_8:
//     glTexImage2D(GL_TEXTURE_2D, tlod, GL_ALPHA, w, h, 0, GL_ALPHA, GL_UNSIGNED_BYTE, data);
       break;

      case GR_TEXFMT_AYIQ_8422:
         src = (unsigned short *)data;
         dest = tbuffer;
//         for (x = 0; x < size; x++)
         while(src < (unsigned short*)data + size)
         {
             //src = (unsigned short *)(data)+x; dest = (unsigned char*)tbuffer +x*4;
             y = (((*src) >> 4) & 0x0f);
             i = (((*src) >> 2) & 0x03);
             q = ((*src) & 0x03);
             *dest++ = (unsigned char)(y + 0.95 * i + 0.62 * q);
             *dest++ = (unsigned char)(y - 0.28 * i - 0.64 * q);
             *dest++ = (unsigned char)(y - 1.11 * i + 1.73 * q);
             *dest++ = (((*src) >> 8) & 0xff);
             src++;
         }
//       glTexImage2D(GL_TEXTURE_2D, tlod, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, tbuffer);
       break;

      case GR_TEXFMT_YIQ_422:
      {
       register const unsigned char *src8 = (unsigned char *)data;
       dest = tbuffer;
//       for (x = 0; x < size; x++)
       while(src8 < (unsigned char *)data + size)
       {
           //src8 = (unsigned char *)(data)+x; dest = (unsigned char*)tbuffer +x*4;
           y = (((*src8) >> 4) & 0x0f);
           i = (((*src8) >> 2) & 0x03);
           q = (((*src8) >> 0) & 0x03);
           *dest++ = (unsigned char)(y + 0.95 * i + 0.62 * q);
           *dest++ = (unsigned char)(y - 0.28 * i - 0.64 * q);
           *dest++ = (unsigned char)(y - 1.11 * i + 1.73 * q);
           *dest++ = 0;
           src8++;
       }
//     glTexImage2D(GL_TEXTURE_2D, tlod, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, tbuffer);
       break;
      }
      case GR_TEXFMT_RGB_332:
       // Untested
/*       for (x = 0; x < size; x++)
       {
           src = (unsigned short *)(data) + x;
           dest = (unsigned char *)tbuffer + x * 4;
           *(dest) = ((*src) & (0x007 << 5)) + (((*src >> 5) & 0x007) << 2) +
           (((*src >> 5) & 0x007) >> 1);
           *(dest + 1) = ((*src << 3) & (0x007 << 5)) + (((*src >> 2) &
               0x007) << 2) + (((*src >> 2) & 0x007) >> 1);
           *(dest + 2) = (((*src) & 0x003) << 6) + (((*src) & 0x003) << 4) +
           (((*src) & 0x003) << 4) + (((*src) & 0x003));
           *(dest + 3) = 0xff;
       }
*/
//     glTexImage2D(GL_TEXTURE_2D, tlod, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, tbuffer);
       break;

        case GR_TEXFMT_ARGB_8332:
           // Untested
//           for (x = 0; x < size; x++)
/*           while(src < (unsigned short*)data + size)
           {
               src = (unsigned short *)(data) + x;
               dest = (unsigned char *)tbuffer + x * 4;
               *(dest) = ((*src) & (0x007 << 5)) + (((*src >> 5) & 0x007) << 2) +
               (((*src >> 5) & 0x007) >> 1);
               *(dest + 1) = ((*src << 3) & (0x007 << 5)) + (((*src >> 2) &
                   0x007) << 2) +
               (((*src >> 2) & 0x007) >> 1);
               *(dest + 2) = (((*src) & 0x003) << 6) + (((*src) & 0x003) << 4) +
               (((*src) & 0x003) << 4) + (((*src) & 0x003));
               *(dest + 3) = (((*src) >> 8) & 0xff);
           }
*/
//     glTexImage2D(GL_TEXTURE_2D, tlod, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, tbuffer);
       break;

     case GR_TEXFMT_RGB_565:
       src = (unsigned short *)data;
       dest = tbuffer;
//       for (x = 0; x < size; x++)
       while(src < (unsigned short*)data + size)
       {
           //src = (unsigned short *)(data)+x; dest = (unsigned char*)tbuffer +x*4;
           *dest++ = (((*src >> 11) & 0x001f) << 3) + (((*src >> 11) & 0x001f) >> 2);
           *dest++ = (((*src >> 5) & 0x003f) << 2) + (((*src >> 5) & 0x003f) >> 4);
           *dest++ = (((*src >> 0) & 0x001f) << 3) + (((*src >> 0) & 0x001f) >> 2);
           *dest++ = 0xff;
           src++;
       }

//     glTexImage2D(GL_TEXTURE_2D, tlod, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, tbuffer);
       break;

     case GR_TEXFMT_ARGB_1555:
     {
#if 1
       src = (unsigned short *)data;
       //dest = tbuffer;
       register unsigned long *destw=(unsigned long *)tbuffer;
//       for (x = 0; x < size; x++)
       while(src < (unsigned short*)data + size)
       {
       	/**destw++ = ( ((*src >> 10) & 0x001f) << 3) |
                      ( ((*src >> 10) & 0x001c) >> 2) |
                      ( ((*src >>  5) & 0x001f) << 11) |
                      ( ((*src >>  5) & 0x001c) << 6) |
                      ( ((*src      ) & 0x001f) << 19) |
                      ( ((*src      ) & 0x001c) << 14) |
					   ((*src & 0x8000) ? 0xff000000 : 0);*/
           *destw++ = ((*src & 0x7c00) >> 7)   // r
                   |  ((*src & 0x03e0) << 6)   // g
                   |  ((*src & 0x001f) << 19) // b
                   |  ((*src & 0x8000) ? 0xff000000 : 0);             // a
           /*
           *destw++ = ((*src & 0x7c00) >> 7)  | ((*src & 0x7c00) >> 12)  // r
                   |  ((*src & 0x03e0) << 6)  | ((*src & 0x0380) << 1)  // g
                   |  ((*src & 0x001f) << 19) | ((*src & 0x001c) << 14)  // b
                   |  ((*src & 0x8000) ? 0xff000000 : 0);             // a*/
           /*if (*src & 0x8000)
           	*destw|=0xf8000000;
           destw++;*/
           //src = (unsigned short *)(data)+x; dest = (unsigned char*)tbuffer +x*4;
           /*
           *dest++  = (((*src >> 10) & 0x001f) << 3) | (((*src >> 10) &
               0x001f) >> 2);
           *dest++ = (((*src >> 5) & 0x001f) << 3) | (((*src >> 5) &
               0x001f) >> 2);
           *dest++ = ((*src & 0x001f) << 3) | ((*src & 0x001f) >> 2);
           *dest++ = ~ ((*src >> 15) & 0x0001);*/
           src++;
       }
//     glTexImage2D(GL_TEXTURE_2D, tlod, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, tbuffer);
#else
       src = (unsigned short *)data;
       register unsigned short *destw = (unsigned short *)tbuffer;
//       for (x = 0; x < size; x++)
       while(src < (unsigned short*)data + size)
       {
//           *destw++=((*src&0x7fff)<<1) | ((*src&0x8000) ? 1 : 0);
           *destw++=((*src&0x7fff)<<1) | ((*src&0x8000) >>15);
           src++;
       }
       texture_type = GL_UNSIGNED_SHORT_5_5_5_1_EXT;
#endif
		texture_iformat = GL_RGB5_A1;
       break;
     }
     case GR_TEXFMT_ARGB_4444:
     {
//		texture_iformat = GL_RGBA4;
#if 1
       src = (unsigned short *)data;
       //dest = tbuffer;
       register unsigned long *destw = (unsigned long *)tbuffer;
//       for (x = 0; x < size; x++)
       while(src < (unsigned short*)data + size)
       {
           //src = (unsigned short *)(data)+x; dest = (unsigned char*)tbuffer +x*4;
            *destw++=((*src&0xf000)<<16)
             | ((*src&0x0f00)>>4)
             | ((*src&0x00f0)<<8)
             | ((*src&0x000f)<<20);
            /*
            *destw++=((*src&0xf000)<<16)|((*src&0xf000)<<12)
             | ((*src&0x0f00)>>4)|((*src&0x0f00)>>8)
             | ((*src&0x00f0)<<8)|((*src&0x00f0)<<4)
             | ((*src&0x000f)<<20)|((*src&0x000f)<<16);*/


           /**dest++ = (((*src >> 8) & 0x000f) << 4) | ((*src >> 8) & 0xf);
           *dest++ = (((*src >> 4) & 0x000f) << 4) | ((*src >> 4) & 0xf);
           *dest++ = ((*src & 0x000f) << 4) | (*src  & 0xf);
           *dest++ = (((*src >> 12) & 0x000f) << 4) | ((*src >> 12) & 0xf); //a*/
           src++;
       }

//     glTexImage2D(GL_TEXTURE_2D, tlod, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, tbuffer);
#else
       src = (unsigned short *)data;
       register unsigned short *destw = (unsigned short *)tbuffer;
//       for (x = 0; x < size; x++)
       while(src < (unsigned short*)data + size)
       {
           *destw++=((*src&0x0fff)<<4) | ((*src&0xf000)>>12);
           src++;
       }
       texture_type = GL_UNSIGNED_SHORT_4_4_4_4_EXT;
#endif
       break;
     }
    default:
       break;
    }
//    static const float	white_col[4]={1,1,1,1};
//  glTexEnvfv(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, white_col);
//  glTexEnvfv(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, (GLfloat*)&g_gr_state.constant_color);
//  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);
/*    int tlod;

    switch (evenOdd)
    {
    case GR_MIPMAPLEVELMASK_BOTH:
    default:
       tlod = (thisLod - largeLod);
       break;
    case GR_MIPMAPLEVELMASK_EVEN:
       tlod = ((thisLod - largeLod) / 2) - 1;
       break;
    case GR_MIPMAPLEVELMASK_ODD:
       tlod = (thisLod - 1 - largeLod) / 2;
       break;
    }*/
//    glTexImage2D (GL_TEXTURE_2D, tlod, GL_RGBA, w, h, 0, texture_format,
//     texture_type, (void*)tbuffer);

    glTexImage2D (GL_TEXTURE_2D, 0, texture_iformat, w, h, 0, texture_format,
       texture_type, (void*)tbuffer);
	/*gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, w, h, texture_format,
       texture_type, (void*)tbuffer);*/

    //glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    //glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    /*SetMipMapMode(nTmu, g_gr_tmu[nTmu].mipmap_mode);
	 grTexClampMode (nTmu, g_gr_tmu[nTmu].s_clampmode, g_gr_tmu[nTmu].t_clampmode);*/

    ptex->info.smallLod = thisLod;
    ptex->info.largeLod = largeLod;
    ptex->info.aspectRatio = aspectRatio;
    ptex->info.format = format;
    ptex->info.data = data;
}

FX_ENTRY void FX_CALL grTexDownloadMipMapLevelPartial (GrChipID_t tmu, FxU32 startAddress,
    GrLOD_t thisLod, GrLOD_t largeLod, GrAspectRatio_t aspectRatio,
    GrTextureFormat_t format, FxU32 evenOdd, void *data,
    int start,
    int end)
{
    TRACEFUNCTION ("grTexDownloadMipMapLevelPartial");

//      WARNING("Not supported yet");
}


FX_ENTRY void FX_CALL ConvertAndDownloadRle (GrChipID_t tmu, FxU32 startAddress,
    GrLOD_t thisLod, GrLOD_t largeLod, GrAspectRatio_t aspectRatio,
    GrTextureFormat_t format, FxU32 evenOdd, FxU8 * bm_data, long bm_h,
    FxU32 u0,
    FxU32 v0,
    FxU32 width,
    FxU32 height,
    FxU32 dest_width,
    FxU32 dest_height,
    FxU16 * tlut)
{
    TRACEFUNCTION ("ConvertAndDownloadRle");

//      WARNING("Not supported yet");
}

FX_ENTRY void FX_CALL grCheckForRoom (FxI32 n)
{
    TRACEFUNCTION ("grCheckForRoom");

//      WARNING("Not supported yet");
}

FX_ENTRY void FX_CALL grTexDownloadTable (GrChipID_t tmu, GrTexTable_t type, void *data)
{
    TRACEFUNCTION ("grTexDownloadTable");

//      WARNING("Not supported yet");
}

FX_ENTRY void FX_CALL grTexDownloadTablePartial (GrChipID_t tmu,
    GrTexTable_t type, void *data,
    int start,
    int end)
{
    TRACEFUNCTION ("grTexDownloadTablePartial");

//      WARNING("Not supported yet");
}

FX_ENTRY void FX_CALL grTexMipMapMode (GrChipID_t tmu, GrMipMapMode_t mode,
    FxBool lodBlend)
{
    TRACEFUNCTION ("grTexMipMapMode");

}

FX_ENTRY void FX_CALL grTexMultibase (GrChipID_t tmu, FxBool enable)
{
    TRACEFUNCTION ("grTexMultibase");

//      WARNING("Not supported yet");
}

FX_ENTRY void FX_CALL grTexMultibaseAddress (GrChipID_t tmu,
    GrTexBaseRange_t range, FxU32 startAddress, FxU32 evenOdd, GrTexInfo * info)
{
    TRACEFUNCTION ("grTexMultibaseAddress");

//      WARNING("Not supported yet");
}

/////////////////////////////////////////////////////////////////////////////




